#include "obj09_db_api.h"
#include "obj09_db_dbd.h"

using namespace RDM_CPP;

Db_obj09_db Db_obj09_db::Open (char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), "obj09_db", mode, &obj09_db_dbd, sizeof(obj09_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj09_db Db_obj09_db::Open (wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), L"obj09_db", mode, &obj09_db_dbd, sizeof(obj09_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

Db_obj09_db Db_obj09_db::Open (const char *name, const char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj09_db_dbd, sizeof(obj09_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj09_db Db_obj09_db::Open (const wchar_t *name, const wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj09_db_dbd, sizeof(obj09_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

dbType Db_obj09_db::Type (void) {
    char static type;
    return &type;
}

Db_obj09_db::Db_obj09_db (void) throw () {
}

Db_obj09_db::Db_obj09_db (const Db& db) throw () : Db (db, Type()) {
}

Db_obj09_db::Db_obj09_db (const Db_obj09_db& db) throw () : Db (db) {
}

Db_obj09_db::Db_obj09_db (IDb *idb) : Db (idb) {
}

Db_obj09_db& Db_obj09_db::operator = (const Db& db) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), db);
    return *this;
}

Db_obj09_db& Db_obj09_db::operator = (const Db_obj09_db& db) throw () {
    *((Db *)this) = db;
    return *this;
}

Db_obj09_db::~Db_obj09_db () {
}

Cursor_office Db_obj09_db::New_office_record (void) const throw (rdm_exception&) {
    return Cursor_office (NewRecords (Cursor_office::Type ()));
}

Cursor_office Db_obj09_db::New_office_recordWithFieldValues (struct office *fields) const throw (rdm_exception&) {
    return Cursor_office (NewRecordsWithFieldValues (Cursor_office::Type (), fields));
}

Cursor_office Db_obj09_db::Get_office_records (void) const throw (rdm_exception&) {
    return Cursor_office (GetRecords (Cursor_office::Type ()));
}

Cursor_office Db_obj09_db::Get_office_recordsBy_name () const throw (rdm_exception&) {
    return Cursor_office (GetRecordsByKey (OFFICE_NAME));
}

recordType Cursor_office::Type (void) {
    return OFFICE;
}

Cursor_office::Cursor_office (void) throw () {
}

Cursor_office::Cursor_office (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_office::Cursor_office (const Cursor_office& cursor) throw () : Cursor (cursor) {
}

Cursor_office& Cursor_office::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_office& Cursor_office::operator = (const Cursor_office& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_office Cursor_office::GetRecordsBy_name () const throw (rdm_exception&) {
    return Cursor_office (GetRecordsByKey (OFFICE_NAME));
}

void Cursor_office::KeyFindBy_name (char name_val[32]) const throw (rdm_exception&) {
    FindRecordsByKey(OFFICE_NAME, 0, 0, name_val);
}

void Cursor_office::SetFieldValues (const struct office *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_office::GetFieldValues (struct office *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_office::Set_name (const char name_val[32]) const throw (rdm_exception&) {
    SetField (OFFICE_NAME, name_val);
}

void Cursor_office::Get_name (char name_val[32]) const throw (rdm_exception&) {
    GetField (OFFICE_NAME, name_val);
}

Cursor_office::~Cursor_office () {
}

